/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   api-type-documentation.html
 */

/// <reference path="../polymer/types/polymer-element.d.ts" />
/// <reference path="../polymer/types/lib/elements/dom-if.d.ts" />
/// <reference path="../raml-aware/raml-aware.d.ts" />
/// <reference path="../markdown-styles/markdown-styles.d.ts" />
/// <reference path="../marked-element/marked-element.d.ts" />
/// <reference path="../iron-flex-layout/iron-flex-layout.d.ts" />
/// <reference path="../api-type-document/api-type-document.d.ts" />
/// <reference path="../api-annotation-document/api-annotation-document.d.ts" />
/// <reference path="../api-resource-example-document/api-resource-example-document.d.ts" />
/// <reference path="../api-schema-document/api-schema-document.d.ts" />

declare namespace ApiElements {

  /**
   * `api-type-documentation`
   *
   * A documentation module for RAML types (resources) using AMF data model
   *
   * ## Styling
   *
   * `<api-type-documentation>` provides the following custom properties and mixins for styling:
   *
   * Custom property | Description | Default
   * ----------------|-------------|----------
   * `--api-type-documentation` | Mixin applied to this elment | `{}`
   */
  class ApiTypeDocumentation extends Polymer.Element {

    /**
     * `raml-aware` scope property to use.
     */
    aware: string|null|undefined;

    /**
     * Generated AMF json/ld model form the API spec.
     * The element assumes the object of the first array item to be a
     * type of `"http://raml.org/vocabularies/document#Document`
     * on AMF vocabulary.
     *
     * It is only usefult for the element to resolve references.
     */
    amfModel: object|any[]|null;

    /**
     * A type definition to render.
     * This should be a one of the following AMF types:
     *
     * - `http://www.w3.org/ns/shacl#NodeShape` (Object)
     * - `http://raml.org/vocabularies/shapes#UnionShape` (Union)
     * - `http://raml.org/vocabularies/shapes#ArrayShape` (Array)
     * - `http://raml.org/vocabularies/shapes#ScalarShape` (single property)
     */
    type: object|any[]|null;

    /**
     * Computed value, title of the type.
     */
    readonly typeTitle: string|null|undefined;

    /**
     * Computed value of method description from `method` property.
     */
    readonly description: string|null|undefined;

    /**
     * Computed value from current `method`. True if the model contains
     * custom properties (annotations in RAML).
     */
    readonly hasCustomProperties: boolean|null|undefined;

    /**
     * Computed value, true when passed model represents a schema
     * (like XML)
     */
    readonly isSchema: boolean|null|undefined;

    /**
     * Computed value of examples in the body model.
     */
    readonly examples: Array<object|null>|null;

    /**
     * Computed valie if examples are set.
     */
    readonly hasExamples: boolean|null|undefined;

    /**
     * Gets a signle scalar value from a model.
     *
     * @param model Amf model to extract the value from.
     * @param key Model key to search for the value
     * @returns Value for key
     */
    _getValue(model: object|null, key: String|null): any|null;

    /**
     * Computes `typeTitle` property
     */
    _computeTitle(shape: any): String|null|undefined;

    /**
     * Computes `description` property
     *
     * @param shape AMF model for data type
     */
    _computeDescription(shape: object|null): String|null|undefined;

    /**
     * Computes value for `hasCustomProperties` property.
     *
     * @param shape AMF `supportedOperation` model
     */
    _computeHasCustomProperties(shape: object|null): Boolean|null;

    /**
     * Computes value for `isSchema` property.
     *
     * @param shape AMF `supportedOperation` model
     */
    _computeIsSchema(shape: object|null): Boolean|null;

    /**
     * Computes `examples` property from AMF model.
     *
     * @param shape AMF `supportedOperation` model
     * @returns List of examples in the type
     */
    _computeExamples(shape: object|null): any[]|null|undefined;

    /**
     * Computes value for `hasExamples`
     *
     * @param examples Current `examples`
     */
    _computeHasExamples(examples: any[]|null): Boolean|null;
  }
}

interface HTMLElementTagNameMap {
  "api-type-documentation": ApiElements.ApiTypeDocumentation;
}
